/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright (c) 2013 Oracle and/or its affiliates. All rights reserved.
 *
 * The contents of this file are subject to the terms of the GNU General
 * Public License Version 2 only ("GPL"). You may not use this file except
 * in compliance with the License.  You can obtain a copy of the License at
 * https://avatar.java.net/license.html or legal/LICENSE.txt.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 *
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at legal/LICENSE.txt.
 *
 * GPL Classpath Exception:
 * Oracle designates this particular file as subject to the "Classpath"
 * exception as provided by Oracle in the GPL Version 2 section of the License
 * file that accompanied this code.
 *
 * Modifications:
 * If applicable, add the following below the License Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyright [year] [name of copyright owner]"
 *
 */

var avatar = require("org/glassfish/avatar");

var message = 'The server time is ';

var getTime = function() {
    var current = new Date();
    return {
        msg: message,
        h: current.getHours(),
        m: current.getMinutes(),
        s: current.getSeconds() };
};

avatar.registerRestService({ url: "data/message" },
    function() {
        this.onPut = function(request, response) {
            message = request.data.msg;
            response.send(null);
        };
    }
);

avatar.registerPushService({ url: "push/time" },
    function() {
        this.onOpen = this.onTimeout = function(context) {
            context.setTimeout(1000);
            return context.sendMessage(getTime());
        };
    }
);
